// ProcessVariable.h : Declaration of the CProcessVariable

#ifndef __PROCESSVARIABLE_H_
#define __PROCESSVARIABLE_H_

#include "resource.h"       // main symbols
#include "EpicsCAClientCP.h"
#include "EpicsProcessVariable.h"

/////////////////////////////////////////////////////////////////////////////
// CProcessVariable
//


#ifdef _DEBUG
// Yet another single-linked list template,
// but this one is simple enough so that the
// MS debugger can understand it at run time
template <class T>
class SLList
{
public:
	SLList ()
	{
		sl_next = 0;
	}

	void add (T *item)
	{
		item->sl_next = sl_next;
		sl_next = item;
	}

	bool remove (T *item)
	{
		T **current = &sl_next;

		while (*current != item)
			current = & ((*current)->sl_next);

		if (*current)
		{
			*current = (*current)->sl_next;
			return true;
		}

		return false;
	}

protected:
	T *sl_next;
};
#endif

// This is our exported ActiveX coClass.
// Is will transfer most calls to its
// CEpicsProcessVariable member.
class ATL_NO_VTABLE CProcessVariable : 
#ifdef _DEBUG
	public SLList<CProcessVariable>,
#endif
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CProcessVariable, &CLSID_ProcessVariable>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CProcessVariable>,
	public IProvideClassInfo2Impl<&CLSID_ProcessVariable, &DIID__IProcessVariableEvents, &LIBID_EpicsCAClient>,
	public IDispatchImpl<IProcessVariable, &IID_IProcessVariable, &LIBID_EpicsCAClient>,
	public CProxy_IProcessVariableEvents< CProcessVariable >
{
public:
	CProcessVariable();
	~CProcessVariable();

DECLARE_REGISTRY_RESOURCEID(IDR_PROCESSVARIABLE)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CProcessVariable)
	COM_INTERFACE_ENTRY(IProcessVariable)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()
BEGIN_CONNECTION_POINT_MAP(CProcessVariable)
CONNECTION_POINT_ENTRY(DIID__IProcessVariableEvents)
END_CONNECTION_POINT_MAP()


// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IProcessVariable
public:
	STDMETHOD(get_callback)();
	STDMETHOD(put_callback)(/*[in]*/ VARIANT newVal);
	STDMETHOD(get_is_connected)(/*[out, retval]*/ BOOL *pVal);
	STDMETHOD(get_type)(/*[out, retval]*/ short *pVal);
	STDMETHOD(get_value)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(put_value)(/*[in]*/ VARIANT newVal);
	STDMETHOD(get_units)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_name)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_name)(/*[in]*/ BSTR newVal);

private:
	CEpicsProcessVariable	*m_epv;

	static void ConnectCallback (void *arg);
	static void NewValueCallback (void *arg);
};

#endif //__PROCESSVARIABLE_H_
