% Connect to the "EpicsCAClient" ActiveX Automation Server,
% create a "ProcessVariable" on there:
pv = actxserver('EpicsCAClient.ProcessVariable');

% 'alan' is an array served by excas (100 double entries)
pv.name = 'ExampleArray';

% The EpicsCAClient.Processvariable sends an ActiveX Event when the connection
% status and/or value changes.
% In Visual Basic we would prepare to catch the "Changed" event and spend our
% time doing something useful until we receive the "Changed" event.
% But Matlab cannot handle events for ActiveX _servers_ (only "controls").
% So all we can do is sit in a busy wait loop until the connection comes up.
% If the PV doesn't exist, we will be stuck in here forever....
while pv.is_connected == 0,
    pause(0.1)
end

pause(1.0)

plot(pv.value);

% Ask the EpicsCAServer to remove out ProcessVariable.
% It will disconnect from ChannelAccess, the 'pv' is useless from now on:
% delete(pv);

