function varargout = arraydisplay(varargin)
% ARRAYDISPLAY Application M-file for arraydisplay.fig
%    FIG = ARRAYDISPLAY launch arraydisplay GUI.
%    ARRAYDISPLAY('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.0 30-Jan-2002 18:10:31

if nargin == 0  % LAUNCH GUI
	fig = openfig(mfilename,'reuse');	% Generate a structure of handles to pass to callbacks, and store it. 
	handles = guihandles(fig);
	guidata(fig, handles);
	if nargout > 0
		varargout{1} = fig;
	end
elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK
	try
		if (nargout)
			[varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
		else
			feval(varargin{:}); % FEVAL switchyard
		end
	catch
		disp(lasterr);
	end
end

%| ABOUT CALLBACKS:
%| GUIDE automatically appends subfunction prototypes to this file, and 
%| sets objects' callback properties to call them through the FEVAL 
%| switchyard above. This comment describes that mechanism.
%|
%| Each callback subfunction declaration has the following form:
%| <SUBFUNCTION_NAME>(H, EVENTDATA, HANDLES, VARARGIN)
%|
%| The subfunction name is composed using the object's Tag and the 
%| callback type separated by '_', e.g. 'slider2_Callback',
%| 'figure1_CloseRequestFcn', 'axis1_ButtondownFcn'.
%|
%| H is the callback object's handle (obtained using GCBO).
%|
%| EVENTDATA is empty, but reserved for future use.
%|
%| HANDLES is a structure containing handles of components in GUI using
%| tags as fieldnames, e.g. handles.figure1, handles.slider2. This
%| structure is created at GUI startup using GUIHANDLES and stored in
%| the figure's application data using GUIDATA. A copy of the structure
%| is passed to each callback.  You can store additional information in
%| this structure at GUI startup, and you can change the structure
%| during callbacks.  Call guidata(h, handles) after changing your
%| copy to replace the stored original so that subsequent callbacks see
%| the updates. Type "help guihandles" and "help guidata" for more
%| information.
%|
%| VARARGIN contains any extra arguments you have passed to the
%| callback. Specify the extra arguments by editing the callback
%| property in the inspector. By default, GUIDE sets the property to:
%| <MFILENAME>('<SUBFUNCTION_NAME>', gcbo, [], guidata(gcbo))
%| Add any extra arguments after the last argument, before the final
%| closing parenthesis.

% --------------------------------------------------------------------
function varargout = pvname_Callback(h, eventdata, handles, varargin)
x0=str2num(get(handles.x0, 'string'));
dx=str2num(get(handles.dx, 'string'));

pv = actxserver('EpicsCAClient.ProcessVariable');
name = get(handles.pvname,'string');
pv.name = name;
fprintf(1, 'Connecting to PV %s\n', name);
while pv.is_connected == 0,
    pause(1)
end
fprintf(1, 'Connected\n');

x=(1:length(pv.value)) * dx + x0;
pl=plot(x, pv.value, 'b', 'Parent', handles.graph);
set(handles.graph, 'xgrid', 'on')
set(handles.graph, 'ygrid', 'on')
set(get(handles.graph, 'XLabel'), 'String', 'Bins');
set(get(handles.graph, 'YLabel'), 'String', pv.units);

% Remove flicker
set(gcf, 'DoubleBuffer', 'on');
% Save some memory
set(gcf, 'BackingStore', 'off');
%set(gcf, 'Renderer', 'OpenGL');
run = 1;
set(handles.fig, 'UserData', run);
while run
    set(pl, 'YData', pv.value);
    drawnow;
    run = get(handles.fig, 'UserData');
end
fprintf(1, 'Disconnecting\n');
delete(pv);
% close(handles.fig);

% --------------------------------------------------------------------
function varargout = stop_Callback(h, eventdata, handles, varargin)
run = 0;
set(handles.fig, 'UserData', run);
fprintf(1, 'Request stop\n');

